#include "stdafx.h"
#include "SMSSender.h"
#include "SMSSenderDlg.h"
#include "enumser.h" //If you get a compilation error about this missing header file, then you need to download my EnumSerialPorts class from http://www.naughter.com/enumser.html


#ifdef _DEBUG
#define new DEBUG_NEW
#endif //#ifdef _DEBUG


#pragma warning(suppress: 26455)
CSMSSenderDlg::CSMSSenderDlg(_In_opt_ CWnd* pParent) : CDialog{CSMSSenderDlg::IDD, pParent},
                                                       m_nRelativeValidityPeriod{86400},
                                                       m_AbsoluteDate{0},
                                                       m_AbsoluteTime{0},
                                                       m_nRelative{0}, //Use a relative Validity period
                                                       m_bValidityPeriod{FALSE},
                                                       m_bRequireStatusReport{FALSE},
                                                       m_nPhoneNumberFormat{0},
                                                       m_nSMSCFormat{0},
                                                       m_nEncoding{0},
                                                       m_dwTimeout{15000},
                                                       m_hIcon{AfxGetApp()->LoadIcon(IDR_MAINFRAME)}
{
  CTime MidnightTonight{CTime::GetCurrentTime()};
  MidnightTonight = CTime(MidnightTonight.GetYear(), MidnightTonight.GetMonth(), MidnightTonight.GetDay(), 23, 59, 59);
  m_AbsoluteDate = MidnightTonight;
  m_AbsoluteTime = MidnightTonight;
  m_sReplacementCharacter = _T("_");
}

#pragma warning(suppress: 26429)
void CSMSSenderDlg::DoDataExchange(CDataExchange* pDX)
{
  __super::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_CHARACTERS_LEFT, m_ctrlCharactersLeft);
  DDX_Control(pDX, IDC_MESSAGE, m_ctrlMessage);
  DDX_Control(pDX, IDC_PORT, m_ctrlPorts);
  DDX_Control(pDX, IDC_ABSOLUTE_DATE, m_ctrlAbsoluteDate);
  DDX_Control(pDX, IDC_ABSOLUTE_TIME, m_ctrlAbsoluteTime);
  DDX_Text(pDX, IDC_DESTINATION_NUMBER, m_sDestinationNumber);
  DDX_Text(pDX, IDC_MESSAGE, m_sMessage);
  DDX_Text(pDX, IDC_SERVICE_CENTER_NUMBER, m_sServiceCenterNumber);
  DDX_Text(pDX, IDC_RELATIVE_VALIDITY_PERIOD, m_nRelativeValidityPeriod);
  DDX_Text(pDX, IDC_REPLACEMENT_CHARACTER, m_sReplacementCharacter);
  DDX_DateTimeCtrl(pDX, IDC_ABSOLUTE_DATE, m_AbsoluteDate);
  DDX_DateTimeCtrl(pDX, IDC_ABSOLUTE_TIME, m_AbsoluteTime);
  DDX_Radio(pDX, IDC_RELATIVE, m_nRelative);
  DDX_Check(pDX, IDC_VALIDITY_PERIOD, m_bValidityPeriod);
  DDX_Check(pDX, IDC_STATUS_REPORT, m_bRequireStatusReport);
  DDX_CBIndex(pDX, IDC_PHONENUMBER_FORMAT, m_nPhoneNumberFormat);
  DDX_CBIndex(pDX, IDC_SMSC_FORMAT, m_nSMSCFormat);
  DDX_CBIndex(pDX, IDC_ENCODING, m_nEncoding);
  DDX_Text(pDX, IDC_TIMEOUT, m_dwTimeout);
  if (pDX->m_bSaveAndValidate)
  {
    if (m_sReplacementCharacter.IsEmpty())
    {
      AfxMessageBox(_T("Please specify a valid replacement character"));
      pDX->PrepareEditCtrl(IDC_REPLACEMENT_CHARACTER);
      pDX->Fail();
    }
    if (m_sDestinationNumber.IsEmpty())
    {
      AfxMessageBox(_T("Please specify a valid Destination Phone Number"));
      pDX->PrepareEditCtrl(IDC_DESTINATION_NUMBER);
      pDX->Fail();
    }
  }
}

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CSMSSenderDlg, CDialog) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_PAINT()
  ON_WM_QUERYDRAGICON()
  ON_BN_CLICKED(IDC_SEND, &CSMSSenderDlg::OnSend)
  ON_EN_CHANGE(IDC_MESSAGE, &CSMSSenderDlg::OnChangeMessage)
  ON_BN_CLICKED(IDC_RESCAN, &CSMSSenderDlg::OnRescan)
  ON_CBN_SELCHANGE(IDC_ENCODING, &CSMSSenderDlg::OnSelchangeEncoding)
  ON_EN_CHANGE(IDC_REPLACEMENT_CHARACTER, &CSMSSenderDlg::OnChangeReplacementCharacter)
END_MESSAGE_MAP()

BOOL CSMSSenderDlg::OnInitDialog()
{
  __super::OnInitDialog();
  SetIcon(m_hIcon, TRUE);
  SetIcon(m_hIcon, FALSE);
  OnRescan();
  return TRUE;
}

#pragma warning(suppress: 26434)
void CSMSSenderDlg::OnPaint()
{
  if (IsIconic())
  {
    CPaintDC dc{this}; //device context for painting

#pragma warning(suppress: 26490)
    SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

    //Center icon in client rectangle
    const int cxIcon{GetSystemMetrics(SM_CXICON)};
    const int cyIcon{GetSystemMetrics(SM_CYICON)};
    CRect rect;
    GetClientRect(&rect);
    const int x{(rect.Width() - cxIcon + 1) / 2};
    const int y{(rect.Height() - cyIcon + 1) / 2};

    //Draw the icon
    dc.DrawIcon(x, y, m_hIcon);
  }
  else
    __super::OnPaint();
}

#pragma warning(suppress: 26434 26440)
HCURSOR CSMSSenderDlg::OnQueryDragIcon()
{
#pragma warning(suppress: 26473)
  return static_cast<HCURSOR>(m_hIcon);
}

BOOL CSMSSenderDlg::BuildMessage(BOOL bUpdateData)
{
  if (bUpdateData)
  {
    if (!UpdateData(TRUE))
      return FALSE;
  }
  else
  {
    CDataExchange DX{this, TRUE};
#pragma warning(suppress: 26486)
    DDX_Text(&DX, IDC_MESSAGE, m_sMessage);
    DDX_Text(&DX, IDC_REPLACEMENT_CHARACTER, m_sReplacementCharacter);
    DDX_CBIndex(&DX, IDC_ENCODING, m_nEncoding);
    if (m_sReplacementCharacter.IsEmpty())
      return FALSE;
  }

  //Fill in all the message settings to use
  m_Message.m_sServiceCenterNumber = m_sServiceCenterNumber;
  m_Message.m_sPhoneNumber = m_sDestinationNumber;
  m_Message.m_bUseValidityPeriod = m_bValidityPeriod;
  m_Message.m_bUseRelativeValidityPeriod = (m_nRelative == 0);
  m_Message.m_RelativeValidityPeriod = CTimeSpan{0, 0, 0, m_nRelativeValidityPeriod};
  m_AbsoluteDate.GetAsSystemTime(m_Message.m_AbsoluteValidityPeriod);
#pragma warning(suppress: 26472)
  m_Message.m_AbsoluteValidityPeriod.wHour = static_cast<WORD>(m_AbsoluteTime.GetHour());
#pragma warning(suppress: 26472)
  m_Message.m_AbsoluteValidityPeriod.wMinute = static_cast<WORD>(m_AbsoluteTime.GetMinute());
#pragma warning(suppress: 26472)
  m_Message.m_AbsoluteValidityPeriod.wSecond = static_cast<WORD>(m_AbsoluteTime.GetSecond());
  TIME_ZONE_INFORMATION tzi{};
  if (GetTimeZoneInformation(&tzi) != TIME_ZONE_ID_INVALID)
    m_Message.m_TimeZone = tzi.Bias;
  else
    m_Message.m_TimeZone = 0;
  m_Message.m_bRequireStatusReport = m_bRequireStatusReport;
  m_Message.m_cReplacementCharacter = m_sReplacementCharacter.GetAt(0);
  switch (m_nPhoneNumberFormat)
  {
    case 0:
    {
      if (m_sDestinationNumber.Mid(0, 1) == _T("+"))
      {
        m_Message.m_PhoneNumberAddressType = static_cast<BYTE>(CSMSMessage::PhoneFormat::InternationalFormat);
        m_Message.m_sPhoneNumber = m_sDestinationNumber.Mid(1);
      }
      else if (m_sDestinationNumber.Mid(0, 1) != _T("0"))
        m_Message.m_PhoneNumberAddressType = static_cast<BYTE>(CSMSMessage::PhoneFormat::InternationalFormat);
      else
        m_Message.m_PhoneNumberAddressType = static_cast<BYTE>(CSMSMessage::PhoneFormat::NationalFormat);
      break;
    }
    case 1:
    {
      m_Message.m_PhoneNumberAddressType = static_cast<BYTE>(CSMSMessage::PhoneFormat::InternationalFormat);
      break;
    }
    case 2:
    {
      m_Message.m_PhoneNumberAddressType = static_cast<BYTE>(CSMSMessage::PhoneFormat::NationalFormat);
      break;
    }
    case 3:
    {
      m_Message.m_PhoneNumberAddressType = static_cast<BYTE>(CSMSMessage::PhoneFormat::UnknownFormat);
      break;
    }
    default:
    {
      ASSERT(FALSE);
      break;
    }
  }
  switch (m_nSMSCFormat)
  {
    case 0:
    {
      if (m_sServiceCenterNumber.Mid(0, 1) == _T("+"))
      {
        m_Message.m_ServiceCenterNumberAddressType = static_cast<BYTE>(CSMSMessage::PhoneFormat::InternationalFormat);
        m_Message.m_sServiceCenterNumber = m_sServiceCenterNumber.Mid(1);
      }
      else if (m_sServiceCenterNumber.Mid(0, 1) != _T("0"))
        m_Message.m_ServiceCenterNumberAddressType = static_cast<BYTE>(CSMSMessage::PhoneFormat::InternationalFormat);
      else
        m_Message.m_ServiceCenterNumberAddressType = static_cast<BYTE>(CSMSMessage::PhoneFormat::NationalFormat);
      break;
    }
    case 1:
    {
      m_Message.m_ServiceCenterNumberAddressType = static_cast<BYTE>(CSMSMessage::PhoneFormat::InternationalFormat);
      break;
    }
    case 2:
    {
      m_Message.m_ServiceCenterNumberAddressType = static_cast<BYTE>(CSMSMessage::PhoneFormat::NationalFormat);
      break;
    }
    case 3:
    {
      m_Message.m_ServiceCenterNumberAddressType = static_cast<BYTE>(CSMSMessage::PhoneFormat::UnknownFormat);
      break;
    }
    default:
    {
      ASSERT(FALSE);
      break;
    }
  }
  switch (m_nEncoding)
  {
    case 0:
    {
      m_Message.m_Alphabet = CSMSMessage::Alphabet::GSM_7BIT;
      m_Message.m_sMessage = m_sMessage;
      break;
    }
    case 1:
    {
      m_Message.m_Alphabet = CSMSMessage::Alphabet::UCS2;
      m_Message.m_sMessage = m_sMessage;
      break;
    }
    case 2:
    {
      m_Message.m_Alphabet = CSMSMessage::Alphabet::EIGHTBIT;
      CStringA sAsciiMessage{m_sMessage};
      const int nMessageLength{sAsciiMessage.GetLength()};
      m_Message.m_byMessage.resize(nMessageLength);
      for (int i{0}; i<nMessageLength; i++)
#pragma warning(suppress: 26446)
        m_Message.m_byMessage[i] = sAsciiMessage[i];
      break;
    }
    default:
    {
      ASSERT(FALSE);
      break;
    }
  }

  return TRUE;
}

void CSMSSenderDlg::OnSend()
{
  if (!BuildMessage(TRUE))
    return;

  //Work out the serial port to send on
  const int nCurSel{m_ctrlPorts.GetCurSel()};
  ASSERT(nCurSel != CB_ERR);
#pragma warning(suppress: 26472)
  const int nPort{static_cast<int>(m_ctrlPorts.GetItemData(nCurSel))};

  //Open up the port and send the message
  CSMSSerialPort port;
  try
  {
    port.Open(nPort, m_dwTimeout);
  }
#pragma warning(suppress: 26496)
  catch(CSMSException& e)
  {
    CString sError;
    e.GetErrorMessage(sError.GetBuffer(4096), 4096);
    sError.ReleaseBuffer();
    CString sMsg;
    sMsg.Format(_T("An error occurred opening the port, Error:%08X, %s"), e.m_hr, sError.GetString());
    AfxMessageBox(sMsg);
    return;
  }

  try
  {
    port.Send(m_Message);
  }
#pragma warning(suppress: 26496)
  catch(CSMSException& e)
  {
    CString sError;
    e.GetErrorMessage(sError.GetBuffer(4096), 4096);
    sError.ReleaseBuffer();
    CString sMsg;
    sMsg.Format(_T("An error occurred sending the message, Error:%08X, %s"), e.m_hr, sError.GetString());
    AfxMessageBox(sMsg);
  }
}

void CSMSSenderDlg::OnChangeMessage()
{
  if (!BuildMessage(FALSE))
  {
    SetDlgItemText(IDC_MSG_STATS, _T(""));
    return;
  }

  //Get the stats for the message
  const CSMSMessageStats stats{m_Message.Statistics()};

  //Update the message stats text
  CString sMsg;
  switch (m_Message.m_Alphabet)
  {
    case CSMSMessage::Alphabet::GSM_7BIT:
    {
      sMsg.Format(_T("Characters:%d, Msgs:%d, Replacement characters:%d, Extended characters:%d, Max characters per msg:%d, Max bytes per msg:%d"), stats.m_nUserDataSizeCharacters, stats.m_nMessages, stats.m_nReplacementCharacters, stats.m_nExtendedCharacters, stats.m_nMaxCharactersPerMessage, stats.m_nMaxBytesPerMessage);
      break;
    }
    case CSMSMessage::Alphabet::UCS2:
    {
      sMsg.Format(_T("Characters:%d, Msgs:%d, Max characters per msg:%d, Max bytes per msg:%d"), stats.m_nUserDataSizeCharacters, stats.m_nMessages, stats.m_nMaxCharactersPerMessage, stats.m_nMaxBytesPerMessage);
      break;
    }
    case CSMSMessage::Alphabet::EIGHTBIT:
    {
      sMsg.Format(_T("Bytes:%d, Msgs:%d, Max bytes per msg:%d"), stats.m_nUserDataSizeBytes, stats.m_nMessages, stats.m_nMaxBytesPerMessage);
      break;
    }
  }
  SetDlgItemText(IDC_MSG_STATS, sMsg);
}

void CSMSSenderDlg::OnRescan()
{
  CWaitCursor wait;

  //Enumerate the serial ports
  m_ctrlPorts.ResetContent();
  CEnumerateSerial::CPortAndNamesArray ports;
  if (CEnumerateSerial::UsingSetupAPI1(ports))
  {
    for (const auto& port : ports)
    {
      CString sPort;
#pragma warning(suppress: 26489)
      sPort.Format(_T("COM%u (%s)"), port.first, port.second.c_str());
      const int nIndex{m_ctrlPorts.AddString(sPort)};
      m_ctrlPorts.SetItemData(nIndex, port.first);
    }
  }

  if (ports.size() == 0)
  {
    AfxMessageBox(_T("Unable to find any serial ports on this machine"));
    GetDlgItem(IDC_SEND)->EnableWindow(FALSE);
  }
  else
  {
    //Initially select the first item
    m_ctrlPorts.SetCurSel(0);
  }
}

void CSMSSenderDlg::OnSelchangeEncoding()
{
  OnChangeMessage();
}

void CSMSSenderDlg::OnChangeReplacementCharacter()
{
  OnChangeMessage();
}
