#pragma once

#include "MFCSMS.h"


class CSMSSenderDlg : public CDialog
{
public:
//Constructors / Destructors
  CSMSSenderDlg(_In_opt_ CWnd* pParent = nullptr);
  CSMSSenderDlg(const CSMSSenderDlg&) = delete;
  CSMSSenderDlg(CSMSSenderDlg&&) = delete;
  ~CSMSSenderDlg() = default; //NOLINT(modernize-use-override)

//Methods
  CSMSSenderDlg& operator=(const CSMSSenderDlg&) = delete;
  CSMSSenderDlg& operator=(CSMSSenderDlg&&) = delete;

protected:
//Member variables
  enum { IDD = IDD_SMSSENDER_DIALOG };
  CStatic m_ctrlCharactersLeft;
  CEdit m_ctrlMessage;
  CComboBox m_ctrlPorts;
  CDateTimeCtrl m_ctrlAbsoluteDate;
  CDateTimeCtrl m_ctrlAbsoluteTime;
  CString m_sDestinationNumber;
  CString m_sMessage;
  CString m_sServiceCenterNumber;
  int m_nRelativeValidityPeriod;
  CString m_sReplacementCharacter;
  CTime m_AbsoluteDate;
  CTime m_AbsoluteTime;
  int m_nRelative;
  BOOL m_bValidityPeriod;
  BOOL m_bRequireStatusReport;
  int m_nPhoneNumberFormat;
  int m_nSMSCFormat;
  int m_nEncoding;
  DWORD m_dwTimeout;
  CSMSMessage m_Message;
  HICON m_hIcon;

//Methods
  BOOL OnInitDialog() override;
  void DoDataExchange(CDataExchange* pDX) override;
  BOOL BuildMessage(BOOL bUpdateData);

//Message handlers
  afx_msg void OnPaint();
  afx_msg HCURSOR OnQueryDragIcon();
  afx_msg void OnSend();
  afx_msg void OnChangeMessage();
  afx_msg void OnRescan();
  afx_msg void OnSelchangeEncoding();
  afx_msg void OnChangeReplacementCharacter();

  DECLARE_MESSAGE_MAP()
};
